#include <Zeolite.h>
#include "zbin.h"

#include <zFunc.h>

long zbin_BufferWrite(ZBUF hBuffer, ZVAR hVar) {
											
	CzFunc fBufferWrite;
	if(!fBufferWrite.GetFunc("file.ZBIN.BufferWrite")) {
		zeoReportError("zbin_BufferWrite error:\r\n - cannot get ZBIN function");
		return -1;
	}
	
	if(!fBufferWrite.SetArgValueI(0, VarID_hvar, &hBuffer)) {
		zeoReportError("zbin_BufferWrite error:\r\n - cannot set ZBIN function arg");
		return -1;
	}
	
	if(!fBufferWrite.SetArgValueI(1, VarID_hvar, &hVar)) {
		zeoReportError("zbin_BufferWrite error:\r\n - cannot set ZBIN function arg");
		return -1;
	}
	
	if(!fBufferWrite.Execute2()) {
		zeoReportError("zbin_BufferWrite error:\r\n - call to ZBIN function failed");
		return -1;
	}
	
	long rval = -1;
	if(!fBufferWrite.m_rval.GetValue(VarID_int, &rval)) {
		zeoReportError("zbin_BufferWrite error:\r\n - cannot get rval");
		return -1;
	}
	
	return rval;
}

long zbin_BufferRead(ZBUF hBuffer, ZVAR hVar) {
											
	CzFunc fBufferWrite;
	if(!fBufferWrite.GetFunc("file.ZBIN.BufferRead")) {
		zeoReportError("zbin_BufferRead error:\r\n - cannot get ZBIN function");
		return -1;
	}
	
	if(!fBufferWrite.SetArgValueI(0, VarID_hvar, &hBuffer)) {
		zeoReportError("zbin_BufferRead error:\r\n - cannot set ZBIN function arg");
		return -1;
	}
	
	if(!fBufferWrite.SetArgValueI(1, VarID_hvar, &hVar)) {
		zeoReportError("zbin_BufferRead error:\r\n - cannot set ZBIN function arg");
		return -1;
	}
	
	if(!fBufferWrite.Execute2()) {
		zeoReportError("zbin_BufferRead error:\r\n - call to ZBIN function failed");
		return -1;
	}
	
	long rval = -1;
	if(!fBufferWrite.m_rval.GetValue(VarID_int, &rval)) {
		zeoReportError("zbin_BufferRead error:\r\n - cannot get rval");
		return -1;
	}
	
	return rval;
}
