#include <Zeolite.h>
#include "zMapTypeID.h"
#include <zClasses.h>
#include <zFunc.h>

bool zmapid_GetTypeName(long MapTypeID, bool LongName, ZSTR hReturnVar) {
	
	CzFunc f;
	if(!f.GetFunc("mapid.GetTypeName")) {
		zeoReportError("zmapid_GetTypeName error:\r\n - cannot get function handle");
		return false;
	}
	
	int argid = 0;
	
	if(!f.SetArgValueI(argid++, VarID_mapid, &MapTypeID)) {
		zeoReportError("zmapid_GetTypeName error:\r\n - cannot set function argument");
		return false;
	}
	if(!f.SetArgValueI(argid++, VarID_bool, &LongName)) {
		zeoReportError("zmapid_GetTypeName error:\r\n - cannot set function argument (2)");
		return false;
	}
	
	if(!f.Execute2()) {
		zeoReportError("zmapid_GetTypeName error:\r\n - function call failed");
		return false;
	}
	
	if(!zvar_CopyValue(hReturnVar, f.m_rval)) {
		zeoReportError("zmapid_GetTypeName error:\r\n - cannot copy rval");
		return false;
	}

	return true;
}

long zmapid_GetTypeID(const char* lpTypeName) {

	CzFunc f;
	if(!f.GetFunc("mapid.GetTypeID")) {
		zeoReportError("zmapid_GetTypeName error:\r\n - cannot get function handle");
		return 0;
	}
	
	if(!zstr_SetText(f.GetArgI(0), lpTypeName)) {
		zeoReportError("zmapid_GetTypeName error:\r\n - cannot set function argument");
		return 0;
	}
	
	if(!f.Execute2()) {
		zeoReportError("zmapid_GetTypeName error:\r\n - function call failed");
		return 0;
	}
	
	long rval = 0;
	if(!f.m_rval.GetValue(VarID_mapid, &rval)) {
		zeoReportError("zmapid_GetTypeName error:\r\n - cannot get rval");
		return 0;
	}

	return rval;
}