#include "Zeolite.h"
#include "zformat.h"

CzFormat::CzFormat(void) {
}

CzFormat::~CzFormat(void) {
}

bool CzFormat::Create(const char* lpMapName, const char* lpLongName, const char* lpFileExt, const char* lpNativeProgramName) {
	return Attach(zformat_Create(lpMapName, lpLongName, lpFileExt, lpNativeProgramName));
}
bool CzFormat::CreateGeneric(long MapTypeID, const char* lpLongName, const char* lpFileExt, const char* lpNativeProgramName) {
	return Attach(zformat_CreateGeneric(MapTypeID, lpLongName, lpFileExt, lpNativeProgramName));
}
bool CzFormat::GetByExt(const char* lpMapName, long MapTypeID, const char* lpFileExt) {
	return Attach(zformat_GetFormatByExt(lpMapName, MapTypeID, lpFileExt));
}
bool CzFormat::GetByExt2(ZMAP hMap, const char* lpFileExt) {
	return Attach(zformat_GetFormatByExt2(hMap, lpFileExt));
}
bool CzFormat::GetActiveFormat(const char* lpMapName, long MapTypeID) {
	return Attach(zformat_GetActiveFormat(lpMapName, MapTypeID));
}
bool CzFormat::GetDefaultFormat(const char* lpMapName, long MapTypeID) {
	return Attach(zformat_GetDefaultFormat(lpMapName, MapTypeID));
}
bool CzFormat::SetFlags(unsigned long Flags) {
	if(!IsType(VarID_format))	return false;

	return zformat_SetFlags(m_hVar, Flags);
}
unsigned long CzFormat::GetFlags() {
	if(!IsType(VarID_format))	return 0;

	return zformat_GetFlags(m_hVar);
}
bool CzFormat::SetInfoStr(const char* lpInfoStr) {
	if(!IsType(VarID_format))	return false;

	return zformat_SetInfoStr(m_hVar, lpInfoStr);
}
const char* CzFormat::GetExt() {
	if(!IsType(VarID_format))	return 0;

	return zformat_GetExt(m_hVar);

}
ZLIST CzFormat::GetOptionList() {
	if(!IsType(VarID_format))	return 0;

	return zformat_GetOptionList(m_hVar);

}
bool CzFormat::GetOptionValue(const char* lpOptionName, long VarID, void* pValue) {
	if(!IsType(VarID_format))	return false;

	return zformat_GetOptionValue(m_hVar, lpOptionName, VarID, pValue);

}
bool CzFormat::SetOptionValue(const char* lpOptionName, long VarID, void* pValue) {
	if(!IsType(VarID_format))	return false;

	return zformat_SetOptionValue(m_hVar, lpOptionName, VarID, pValue);

}