#include "Zeolite.h"
#include "zstr.h"
#include <stdio.h>

CzStr::CzStr(void) {
	Create();
}

CzStr::~CzStr(void) {
}

bool CzStr::Create() {
	return CzVar::Create(VarID_string);
}
bool CzStr::CreateShared(const char* lpVarName) {
	return CzVar::CreateShared(VarID_string, lpVarName);
}

const char* CzStr::GetText() {
	if(!m_hVar)	return NULL;

	return zstr_GetText(m_hVar);
}
bool CzStr::SetText(const char* lpTextStr) {
	if(!m_hVar)	return false;

	return zstr_SetText(m_hVar, lpTextStr);
}

long CzStr::GetLength() { 
	if(!m_hVar)	return 0;

	return (long)strlen(GetText()); 
}
bool CzStr::IsStr(const char* lpText) {
	if(!m_hVar)	return false;

	return !Compare(lpText); 
}
long CzStr::Compare(const char* lpText) {
	if(!m_hVar)	return -1;

	return strcmp(GetText(), lpText);
}
long CzStr::CompareNoCase(const char* lpText) {
	if(!m_hVar)	return -1;

	// make both strings lowercase, then return strcmp result
	CzStr s1;
	long len = GetLength();
	for(long i=0; i<len; i++) {
		s1.AppendChar(tolower(GetAt(i)));
	}

	CzStr s2;
	len = strlen(lpText);
	for(long i=0; i<len; i++) {
		s2.AppendChar(tolower(lpText[i]));
	}

	return strcmp((char*)s1, (char*)s2);
}

char CzStr::GetAt(long index) {
	if(!m_hVar)	return 0;

	if(index<0 || index>=GetLength())
		return 0;

	return (GetText()[index]);
}

long CzStr::Find(const char* lpText, long StartPos) {

	if(!m_hVar)	return -1;

	if(!lpText) {
		return -1;
	}

	long slen = (long)strlen(lpText);
	if(!slen) {
		return -1;
	}

	long thislen = GetLength();

	if(StartPos<0 || StartPos>=thislen) {
		return -1;
	}

	for(long p=StartPos; p<thislen; p++) {
		bool IsOK = true;
		for(long q=0; q<slen && p+q<thislen && IsOK; q++) {
			if(lpText[q]!=GetAt(p+q)) {
				IsOK = false;
			}
		}
		if(IsOK) {
			return p;
		}
	}

	return -1;
}

const char* CzStr::Append(const char* lpNewText) {
	if(!m_hVar)	return NULL;

	if(!lpNewText)	return GetText();

	long buflen = GetLength()+(long)strlen(lpNewText)+1;
	if(buflen<1)
		return 0;

	char* pBuf = (char*)malloc(buflen);
	if(!pBuf)	return 0;

	sprintf_s(pBuf, buflen, "%s%s", GetText(), lpNewText);
	SetText(pBuf);

	free(pBuf);
	return GetText();
}
const char* CzStr::AppendChar(char c) {
	if(!m_hVar)	return NULL;

	char c2[2];
	c2[0]=c;
	c2[1]=0;
	return Append(c2);
}